package cn.com.qmth.examcloud.core.basic.service.impl;

import cn.com.qmth.examcloud.api.commons.security.bean.User;
import cn.com.qmth.examcloud.commons.logging.ExamCloudLog;
import cn.com.qmth.examcloud.commons.logging.ExamCloudLogFactory;
import cn.com.qmth.examcloud.commons.util.UUID;
import cn.com.qmth.examcloud.core.basic.base.util.VerifyCode;
import cn.com.qmth.examcloud.core.basic.service.VerifyCodeService;
import cn.com.qmth.examcloud.core.basic.service.bean.VerifyCodeLoginInfo;
import org.apache.commons.codec.binary.Base64;
import org.springframework.stereotype.Service;

/**
 * 验证码相关接口
 */
@Service
public class VerifyCodeServiceImpl implements VerifyCodeService {

    private static final ExamCloudLog log = ExamCloudLogFactory.getLog(VerifyCodeServiceImpl.class);

    /**
     * 验证码生成接口
     *
     * @return 字符串：uuid(32位) + base64
     */
    @Override
    public String verifyCodeGenerate(Long rootOrgId, String accountValue) {
        VerifyCode.Result result = VerifyCode.generateVerifyCode();
        log.info(String.format("accountValue = %s, generateVerifyCode = %s", accountValue, result.getResult()));

        byte[] bytes = VerifyCode.imageToBytes(result.getImage());
        String base64 = Base64.encodeBase64String(bytes);

        //todo

        return UUID.randomUUID() + base64;
    }

    /**
     * 验证码登录接口
     *
     * @return 登录成功信息
     */
    @Override
    public User verifyCodeLogin(VerifyCodeLoginInfo info) {

        log.info(info.getAccountValue() + " - " + info.getVerifyCode());
        //todo

        return null;
    }

    /**
     * Resource接口
     */
    @Override
    public void verifyCodeResource(String uuid) {
        log.info(uuid);
        //todo
    }

}
